﻿// Spore API Sample
// www.sporeapi.com
package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.text.*;	
	import flash.geom.*;
	
	// This class holds an asset
	// It handles the loading of the asset PNG
	// It also has an Update Loop that makes the asset fall
	public class Asset extends MovieClip {  	
		
		public var mId:String;
		public var mApp:SporeWebTest;
		public var mSpawnPoint:Point;
		public var mLoading:Boolean;
		public var mLoaded:Boolean;
		public var mSpeed;
		
		public function Asset(app:SporeWebTest, id:String, spawn:Point, speed:Number):void
		{
			mApp = app;
			mId = id;
			mSpawnPoint = spawn;
			mSpeed = speed;
			this.x = mSpawnPoint.x;
			this.y = mSpawnPoint.y;
			mLoaded = false;
			mLoading = false;
			addEventListener(Event.ENTER_FRAME, Update);
		}
		
		public function LoadPNG()
		{
			mLoading = true;
			mLoaded = false;
			GetSmallPNG(mId);
		}
		
		// Get small 128x128 PNG from asset ID
		public function GetSmallPNG(assetId:String):void
		{
			var subId1:String = assetId.substr(0,3);
			var subId2:String = assetId.substr(3,3);
			var subId3:String = assetId.substr(6,3);
			var smallPNGURL = "http://www.spore.com/static/thumb/"+subId1+"/"+subId2+"/"+subId3+"/"+assetId+".png"
			var smallPNGLoader:Loader = new Loader();
			smallPNGLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, GotSmallPNG);
			smallPNGLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, HandleSmallPNGError);
			smallPNGLoader.load(new URLRequest(smallPNGURL));
		}
		
		public function HandleSmallPNGError(e:IOErrorEvent):void
		{
			trace(e.text);
		}
		
		// Show the assets
		public function GotSmallPNG(e:Event):void
		{
			var smallPNG:Bitmap = e.target.content;
			smallPNG.smoothing = true;
			addChild(smallPNG);
			mLoaded = true;
			mLoading = false;
		}
		
		public function Update(e:Event):void
		{
			if(mLoaded)
			{
				this.y+= mSpeed;
				if(this.y > mApp.mHeight)
				{
					this.y = -Math.random() *10000;
				}
			}
		}

	}
}