﻿// Spore API Sample
// www.sporeapi.com
package {
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.text.*;	
	import flash.geom.*;
	
	// This class holds an asset
	// It handles the loading of the asset PNG
	// It also has an Update Loop that makes the asset fall
	public class Bigfish extends MovieClip {  	
		
		public var mId:String;
		public var mApp:SporeWebTest;
		public var mSpawnPoint:Point;
		public var mLoading:Boolean;
		public var mLoaded:Boolean;
		public var mSpeed;
		public var mDirection;
		public var mSmallPNG;
		public var mPhase;
		
		public function Bigfish(app:SporeWebTest, id:String, spawn:Point, speed:Number):void
		{
			this.buttonMode = true;
			this.useHandCursor = true;
			this.mouseEnabled = true;
			addEventListener(MouseEvent.ROLL_OVER, mouseOver);
			addEventListener(MouseEvent.ROLL_OUT, mouseOut);
			addEventListener(MouseEvent.CLICK, clicked);
			mApp = app;
			mId = id;
			mSpawnPoint = spawn;
			mSpeed = (Math.random() * 1 +.1);
			this.x = mSpawnPoint.x;
			this.y = mSpawnPoint.y;
			mLoaded = false;
			mLoading = false;
			addEventListener(Event.ENTER_FRAME, Update);
			mDirection = Math.random() ;
			if(mDirection >= .5)
			{
			mDirection = 1
			}
			else
			{
			mDirection = 2
			}
			mPhase = (Math.random() * 2 * Math.PI)

		}
		
		public function LoadPNG()
		{
			mLoading = true;
			mLoaded = false;
			GetSmallPNG(mId);
		}
		
		// Get small 128x128 PNG from asset ID
		public function GetSmallPNG(assetId:String):void
		{
			var subId1:String = assetId.substr(0,3);
			var subId2:String = assetId.substr(3,3);
			var subId3:String = assetId.substr(6,3);
			var smallPNGURL = "http://www.spore.com/static/image/"+subId1+"/"+subId2+"/"+subId3+"/"+assetId+"_lrg.png"
			var smallPNGLoader:Loader = new Loader();
			smallPNGLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, GotSmallPNG);
			smallPNGLoader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, HandleSmallPNGError);
			smallPNGLoader.load(new URLRequest(smallPNGURL));
		}
		
		public function HandleSmallPNGError(e:IOErrorEvent):void
		{
			trace(e.text);
		}
		
		// Show the assets
		public function GotSmallPNG(e:Event):void
		{
			var smallPNG:Bitmap = e.target.content;
			smallPNG.smoothing = true;
			addChild(smallPNG);
			if(mDirection == 1)
			{
			smallPNG.scaleX*=-1;
			}			
			mSmallPNG = smallPNG;
			mLoaded = true;
			mLoading = false;
		}		
		
		public function Update(e:Event):void
		{
			if(mLoaded)
			{
				this.y = Math.sin(x / 20 + mPhase) * 10 + mSpawnPoint.y;
				if(mDirection == 1)
				{
					this.x+= mSpeed;
					if(this.x >= 550)
					{
						mDirection = 2;
						mSmallPNG.scaleX*=-1;
						this.x -= 256;

					}
				}
				else
				{	
					this.x-= mSpeed;
				}
				
				if(this.x <=  30)
				{
					mDirection = 1;
					mSmallPNG.scaleX*=-1;
					this.x += 256;

				}
				
			}
		}
		public function clicked(e:MouseEvent) :void{ 
		navigateToURL(new URLRequest("http://www.spore.com/sporepedia#qry=sast-"+mId+""), '_blank');
		}
		
		public function mouseOver(e:MouseEvent):void{
		}
		
		
		
		public function mouseOut(e:MouseEvent):void{
		}

	}
}